(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var log2 = Math.log2;
  var protoOf = kotlin_kotlin.$_$.ka;
  var initMetadataForInterface = kotlin_kotlin.$_$.n9;
  var toString = kotlin_kotlin.$_$.oa;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.k1;
  var initMetadataForClass = kotlin_kotlin.$_$.k9;
  var getStringHashCode = kotlin_kotlin.$_$.i9;
  var THROW_CCE = kotlin_kotlin.$_$.le;
  var initMetadataForObject = kotlin_kotlin.$_$.p9;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.k;
  var charSequenceLength = kotlin_kotlin.$_$.a9;
  var charSequenceGet = kotlin_kotlin.$_$.z8;
  var toString_0 = kotlin_kotlin.$_$.b2;
  var Unit_instance = kotlin_kotlin.$_$.h4;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.x1;
  var arrayConcat = kotlin_kotlin.$_$.a;
  var listOf = kotlin_kotlin.$_$.y6;
  var withSign = kotlin_kotlin.$_$.qa;
  var trimMargin = kotlin_kotlin.$_$.sd;
  var hashCode = kotlin_kotlin.$_$.j9;
  var equals = kotlin_kotlin.$_$.d9;
  var VOID = kotlin_kotlin.$_$.f;
  var initMetadataForCompanion = kotlin_kotlin.$_$.l9;
  var coerceAtLeast = kotlin_kotlin.$_$.ta;
  var getNumberHashCode = kotlin_kotlin.$_$.g9;
  var numberToDouble = kotlin_kotlin.$_$.ga;
  var roundToInt = kotlin_kotlin.$_$.pa;
  var DoubleCompanionObject_instance = kotlin_kotlin.$_$.t3;
  var coerceIn = kotlin_kotlin.$_$.xa;
  var Char = kotlin_kotlin.$_$.xd;
  var toInt = kotlin_kotlin.$_$.kd;
  var numberRangeToNumber = kotlin_kotlin.$_$.ea;
  var slice = kotlin_kotlin.$_$.uc;
  var startsWith = kotlin_kotlin.$_$.xc;
  var isInterface = kotlin_kotlin.$_$.y9;
  var contentEquals = kotlin_kotlin.$_$.i5;
  var coerceAtLeast_0 = kotlin_kotlin.$_$.va;
  var objectCreate = kotlin_kotlin.$_$.ja;
  //endregion
  //region block: pre-declaration
  function toXYZ() {
    return this.q1k().r1k();
  }
  initMetadataForInterface(Color, 'Color');
  initMetadataForClass(ColorComponentInfo, 'ColorComponentInfo');
  initMetadataForClass(WhitePoint, 'WhitePoint');
  initMetadataForObject(Illuminant, 'Illuminant');
  initMetadataForClass(Matrix, 'Matrix');
  initMetadataForCompanion(Companion);
  initMetadataForClass(Ansi16, 'Ansi16', VOID, VOID, [Color]);
  initMetadataForCompanion(Companion_0);
  initMetadataForClass(Ansi256, 'Ansi256', VOID, VOID, [Color]);
  initMetadataForCompanion(Companion_1);
  initMetadataForClass(HSV, 'HSV', VOID, VOID, [Color]);
  initMetadataForClass(ICtCp, 'ICtCp', VOID, VOID, [Color]);
  initMetadataForObject(PqNonlinearity, 'PqNonlinearity');
  initMetadataForClass(GammaTransferFunctions, 'GammaTransferFunctions');
  initMetadataForObject(LinearTransferFunctions, 'LinearTransferFunctions');
  function invoke$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.b1m(r, g, b, alpha) : $super.b1m.call(this, r, g, b, alpha);
  }
  function invoke(r, g, b, alpha) {
    return this.b1m(numberToDouble(r), numberToDouble(g), numberToDouble(b), numberToDouble(alpha));
  }
  function invoke$default_0(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.g1n(r, g, b, alpha) : invoke(r, g, b, alpha);
  }
  function from255(r, g, b, alpha) {
    return this.b1m(r / 255.0, g / 255.0, b / 255.0, alpha / 255.0);
  }
  function from255$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 255 : alpha;
    return $super === VOID ? this.h1n(r, g, b, alpha) : from255(r, g, b, alpha);
  }
  function invoke_0(hex) {
    var tmp = parseHex(validateHex(hex), 0);
    var tmp_0 = parseHex(hex, 1);
    var tmp_1 = parseHex(hex, 2);
    var tmp_2;
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.RGBColorSpace.invoke.<anonymous>' call
    var it = get_hexLength(hex);
    if (it === 4 || it === 8) {
      tmp_2 = parseHex(hex, 3);
    } else {
      tmp_2 = 255;
    }
    return this.h1n(tmp, tmp_0, tmp_1, tmp_2);
  }
  initMetadataForInterface(RGBColorSpace, 'RGBColorSpace');
  initMetadataForCompanion(Companion_2, VOID, [RGBColorSpace]);
  initMetadataForClass(RGB, 'RGB', VOID, VOID, [Color]);
  initMetadataForObject(RGBColorSpaces, 'RGBColorSpaces');
  initMetadataForObject(SRGB, 'SRGB', VOID, VOID, [RGBColorSpace]);
  initMetadataForClass(RGBColorSpaceImpl, 'RGBColorSpaceImpl', VOID, VOID, [RGBColorSpace]);
  initMetadataForObject(SRGBTransferFunctions, 'SRGBTransferFunctions');
  initMetadataForObject(ACESccTransferFunctions, 'ACESccTransferFunctions');
  initMetadataForObject(ACEScctTransferFunctions, 'ACEScctTransferFunctions');
  initMetadataForObject(BT2020TransferFunctions, 'BT2020TransferFunctions');
  initMetadataForObject(BT709TransferFunctions, 'BT709TransferFunctions');
  initMetadataForObject(ROMMTransferFunctions, 'ROMMTransferFunctions');
  initMetadataForInterface(XYZColorSpace, 'XYZColorSpace');
  initMetadataForCompanion(Companion_3, VOID, [XYZColorSpace]);
  initMetadataForClass(XYZ, 'XYZ', VOID, VOID, [Color]);
  initMetadataForObject(XYZColorSpaces, 'XYZColorSpaces');
  initMetadataForClass(XYZColorSpaceImpl, 'XYZColorSpaceImpl', VOID, VOID, [XYZColorSpace]);
  initMetadataForClass(xyY, 'xyY');
  //endregion
  function Color() {
  }
  function ColorComponentInfo(name, isPolar, min, max) {
    this.x1k_1 = name;
    this.y1k_1 = isPolar;
    this.z1k_1 = min;
    this.a1l_1 = max;
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.z1k_1 <= this.a1l_1)) {
      // Inline function 'com.github.ajalt.colormath.ColorComponentInfo.<anonymous>' call
      var message = 'min must be less than or equal to max';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
  }
  function WhitePoint(name, chromaticity) {
    this.b1l_1 = name;
    this.c1l_1 = chromaticity;
  }
  protoOf(WhitePoint).toString = function () {
    return this.b1l_1;
  };
  protoOf(WhitePoint).hashCode = function () {
    var result = getStringHashCode(this.b1l_1);
    result = imul(result, 31) + this.c1l_1.hashCode() | 0;
    return result;
  };
  protoOf(WhitePoint).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof WhitePoint))
      return false;
    var tmp0_other_with_cast = other instanceof WhitePoint ? other : THROW_CCE();
    if (!(this.b1l_1 === tmp0_other_with_cast.b1l_1))
      return false;
    if (!this.c1l_1.equals(tmp0_other_with_cast.c1l_1))
      return false;
    return true;
  };
  function Illuminant() {
    Illuminant_instance = this;
    this.d1l_1 = new WhitePoint('A', xyY_init_$Create$(0.44758, 0.40745));
    this.e1l_1 = new WhitePoint('B', xyY_init_$Create$(0.34842, 0.35161));
    this.f1l_1 = new WhitePoint('C', xyY_init_$Create$(0.31006, 0.31616));
    this.g1l_1 = new WhitePoint('D50', xyY_init_$Create$(0.3457, 0.3585));
    this.h1l_1 = new WhitePoint('D55', xyY_init_$Create$(0.33243, 0.34744));
    this.i1l_1 = new WhitePoint('D65', xyY_init_$Create$(0.3127, 0.329));
    this.j1l_1 = new WhitePoint('D75', xyY_init_$Create$(0.29903, 0.31488));
    this.k1l_1 = new WhitePoint('E', xyY_init_$Create$(1.0 / 3.0, 1.0 / 3.0));
  }
  var Illuminant_instance;
  function Illuminant_getInstance() {
    if (Illuminant_instance == null)
      new Illuminant();
    return Illuminant_instance;
  }
  function get_alphaInfo() {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return alphaInfo;
  }
  var alphaInfo;
  function zeroOneComponentInfo(name) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), false, 0.0, 1.0);
      this_0.e(tmp$ret$0);
    }
    this_0.e(get_alphaInfo());
    return this_0.o5();
  }
  function polarComponentInfo(name, l, r) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), item === _Char___init__impl__6a9atx(72), item === _Char___init__impl__6a9atx(72) ? 0.0 : l, item === _Char___init__impl__6a9atx(72) ? 360.0 : r);
      this_0.e(tmp$ret$0);
    }
    this_0.e(get_alphaInfo());
    return this_0.o5();
  }
  function componentInfoList(c) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return listOf(arrayConcat([c, [get_alphaInfo()]]));
  }
  var properties_initialized_ColorSpaceUtils_kt_kskdoe;
  function _init_properties_ColorSpaceUtils_kt__cnwylg() {
    if (!properties_initialized_ColorSpaceUtils_kt_kskdoe) {
      properties_initialized_ColorSpaceUtils_kt_kskdoe = true;
      alphaInfo = new ColorComponentInfo('alpha', false, 0.0, 1.0);
    }
  }
  function get_CAT02_XYZ_TO_LMS() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_XYZ_TO_LMS;
  }
  var CAT02_XYZ_TO_LMS;
  function get_CAT02_LMS_TO_XYZ() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_LMS_TO_XYZ;
  }
  var CAT02_LMS_TO_XYZ;
  var properties_initialized_Constants_kt_w4w61t;
  function _init_properties_Constants_kt__atb1ur() {
    if (!properties_initialized_Constants_kt_w4w61t) {
      properties_initialized_Constants_kt_w4w61t = true;
      CAT02_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.7328, 0.4296, -0.1624, -0.7036, 1.6975, 0.0061, 0.003, 0.0136, 0.9834);
      CAT02_LMS_TO_XYZ = inverse(get_CAT02_XYZ_TO_LMS());
    }
  }
  function spow(_this__u8e3s4, p) {
    return spow_0(_this__u8e3s4, p);
  }
  function normalizeDeg(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function spow_0(_this__u8e3s4, p) {
    // Inline function 'kotlin.math.pow' call
    // Inline function 'kotlin.math.absoluteValue' call
    var this_0 = Math.abs(_this__u8e3s4);
    var tmp$ret$1 = Math.pow(this_0, p);
    return withSign(tmp$ret$1, _this__u8e3s4);
  }
  function normalizeDeg_0(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function _Matrix___init__impl__q3kp4w(rowMajor) {
    return rowMajor;
  }
  function _Matrix___get_rowMajor__impl__vmgxkq($this) {
    return $this;
  }
  function _Matrix___init__impl__q3kp4w_0(v00, v10, v20, v01, v11, v21, v02, v12, v22) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v00, v10, v20, v01, v11, v21, v02, v12, v22]);
    return _Matrix___init__impl__q3kp4w(tmp$ret$0);
  }
  function Matrix__copy_impl_kmkvzd($this) {
    // Inline function 'kotlin.collections.copyOf' call
    // Inline function 'kotlin.js.asDynamic' call
    var tmp$ret$1 = _Matrix___get_rowMajor__impl__vmgxkq($this).slice();
    return _Matrix___init__impl__q3kp4w(tmp$ret$1);
  }
  function Matrix__get_impl_xogbpk($this, x, y) {
    return _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0];
  }
  function Matrix__set_impl_s2l54c($this, x, y, value) {
    _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0] = value;
  }
  function Matrix__set_impl_s2l54c_0($this, x, y, value) {
    return Matrix__set_impl_s2l54c($this, x, y, value);
  }
  function Matrix__toString_impl_l0abk0($this) {
    return trimMargin('Mat3(\n        |   ' + Matrix__get_impl_xogbpk($this, 0, 0) + ', ' + Matrix__get_impl_xogbpk($this, 1, 0) + ', ' + Matrix__get_impl_xogbpk($this, 2, 0) + ', \n        |   ' + Matrix__get_impl_xogbpk($this, 0, 1) + ', ' + Matrix__get_impl_xogbpk($this, 1, 1) + ', ' + Matrix__get_impl_xogbpk($this, 2, 1) + ', \n        |   ' + Matrix__get_impl_xogbpk($this, 0, 2) + ', ' + Matrix__get_impl_xogbpk($this, 1, 2) + ', ' + Matrix__get_impl_xogbpk($this, 2, 2) + ', \n        |)\n        ');
  }
  function Matrix__hashCode_impl_s9ntm9($this) {
    return hashCode($this);
  }
  function Matrix__equals_impl_g5p8p9($this, other) {
    if (!(other instanceof Matrix))
      return false;
    var tmp0_other_with_cast = other instanceof Matrix ? other.l1l_1 : THROW_CCE();
    if (!equals($this, tmp0_other_with_cast))
      return false;
    return true;
  }
  function Matrix(rowMajor) {
    this.l1l_1 = rowMajor;
  }
  protoOf(Matrix).toString = function () {
    return Matrix__toString_impl_l0abk0(this.l1l_1);
  };
  protoOf(Matrix).hashCode = function () {
    return Matrix__hashCode_impl_s9ntm9(this.l1l_1);
  };
  protoOf(Matrix).equals = function (other) {
    return Matrix__equals_impl_g5p8p9(this.l1l_1, other);
  };
  function inverse(_this__u8e3s4, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var a = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0);
    var b = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0);
    var c = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0);
    var d = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1);
    var e = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1);
    var f = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1);
    var g = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2);
    var h = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2);
    var i = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2);
    var A = e * i - h * f;
    var B = h * c - b * i;
    var C = b * f - e * c;
    var det = a * A + d * B + g * C;
    var out = inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4);
    Matrix__set_impl_s2l54c_0(out, 0, 0, A / det);
    Matrix__set_impl_s2l54c_0(out, 0, 1, (g * f - d * i) / det);
    Matrix__set_impl_s2l54c_0(out, 0, 2, (d * h - g * e) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 0, B / det);
    Matrix__set_impl_s2l54c_0(out, 1, 1, (a * i - g * c) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 2, (g * b - a * h) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 0, C / det);
    Matrix__set_impl_s2l54c_0(out, 2, 1, (d * c - a * f) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 2, (a * e - d * b) / det);
    return out;
  }
  function scalarDiv(_this__u8e3s4, x, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var out = _Matrix___get_rowMajor__impl__vmgxkq(inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4));
    var inductionVariable = 0;
    var last = out.length - 1 | 0;
    if (inductionVariable <= last)
      do {
        var i = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        out[i] = out[i] / x;
      }
       while (inductionVariable <= last);
    return _Matrix___init__impl__q3kp4w(out);
  }
  function dot(_this__u8e3s4, other) {
    return _Matrix___init__impl__q3kp4w_0(dot$f(_this__u8e3s4, other, 0, 0), dot$f(_this__u8e3s4, other, 1, 0), dot$f(_this__u8e3s4, other, 2, 0), dot$f(_this__u8e3s4, other, 0, 1), dot$f(_this__u8e3s4, other, 1, 1), dot$f(_this__u8e3s4, other, 2, 1), dot$f(_this__u8e3s4, other, 0, 2), dot$f(_this__u8e3s4, other, 1, 2), dot$f(_this__u8e3s4, other, 2, 2));
  }
  function dotDiagonal(_this__u8e3s4, v0, v1, v2) {
    return _Matrix___init__impl__q3kp4w_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function _Vector___init__impl__y7x4qq(values) {
    return values;
  }
  function _Vector___get_values__impl__3gdbp5($this) {
    return $this;
  }
  function _Vector___init__impl__y7x4qq_0(v0, v1, v2) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v0, v1, v2]);
    return _Vector___init__impl__y7x4qq(tmp$ret$0);
  }
  function _Vector___get_l__impl__envr1l($this) {
    return _Vector___get_values__impl__3gdbp5($this)[0];
  }
  function _Vector___get_m__impl__e5qq0m($this) {
    return _Vector___get_values__impl__3gdbp5($this)[1];
  }
  function _Vector___get_s__impl__pzuljk($this) {
    return _Vector___get_values__impl__3gdbp5($this)[2];
  }
  function dot_0(_this__u8e3s4, v0, v1, v2) {
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var p0 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2;
    var p1 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2;
    var p2 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2;
    return _Vector___init__impl__y7x4qq_0(p0, p1, p2);
  }
  function dot$f($this_dot, $other, x, y) {
    return Matrix__get_impl_xogbpk($this_dot, 0, y) * Matrix__get_impl_xogbpk($other, x, 0) + Matrix__get_impl_xogbpk($this_dot, 1, y) * Matrix__get_impl_xogbpk($other, x, 1) + Matrix__get_impl_xogbpk($this_dot, 2, y) * Matrix__get_impl_xogbpk($other, x, 2);
  }
  function Companion() {
    Companion_instance = this;
    this.m1l_1 = componentInfoList([new ColorComponentInfo('code', false, 30.0, 107.0)]);
  }
  protoOf(Companion).n1l = function () {
    return this.m1l_1;
  };
  var Companion_instance;
  function Companion_getInstance() {
    if (Companion_instance == null)
      new Companion();
    return Companion_instance;
  }
  function Ansi16(code) {
    Companion_getInstance();
    this.o1l_1 = code;
  }
  protoOf(Ansi16).p1k = function () {
    return Companion_getInstance();
  };
  protoOf(Ansi16).q1k = function () {
    switch (this.o1l_1) {
      case 30:
      case 40:
        return Companion_getInstance_2().p1l(0.0, 0.0, 0.0);
      case 90:
      case 100:
        return Companion_getInstance_2().q1l(128, 128, 128);
      case 37:
      case 47:
        return Companion_getInstance_2().q1l(192, 192, 192);
      case 97:
      case 107:
        return Companion_getInstance_2().p1l(1.0, 1.0, 1.0);
    }
    var color = this.o1l_1 % 10 | 0;
    var mul = this.o1l_1 > 50 ? 1.0 : 0.5;
    var r = (color % 2 | 0) * mul;
    var g = ((color / 2 | 0) % 2 | 0) * mul;
    var b = ((color / 4 | 0) % 2 | 0) * mul;
    return Companion_getInstance_2().p1l(r, g, b);
  };
  protoOf(Ansi16).toString = function () {
    return 'Ansi16(code=' + this.o1l_1 + ')';
  };
  protoOf(Ansi16).hashCode = function () {
    return this.o1l_1;
  };
  protoOf(Ansi16).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi16))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi16 ? other : THROW_CCE();
    if (!(this.o1l_1 === tmp0_other_with_cast.o1l_1))
      return false;
    return true;
  };
  function Companion_0() {
    Companion_instance_0 = this;
    this.r1l_1 = componentInfoList([new ColorComponentInfo('code', false, 0.0, 255.0)]);
  }
  protoOf(Companion_0).n1l = function () {
    return this.r1l_1;
  };
  var Companion_instance_0;
  function Companion_getInstance_0() {
    if (Companion_instance_0 == null)
      new Companion_0();
    return Companion_instance_0;
  }
  function Ansi256(code) {
    Companion_getInstance_0();
    this.s1l_1 = code;
  }
  protoOf(Ansi256).p1k = function () {
    return Companion_getInstance_0();
  };
  protoOf(Ansi256).q1k = function () {
    if (this.s1l_1 < 16)
      return this.t1l().q1k();
    if (this.s1l_1 >= 232) {
      var c = imul(this.s1l_1 - 232 | 0, 10) + 8 | 0;
      return Companion_getInstance_2().q1l(c, c, c);
    }
    var c_0 = this.s1l_1 - 16 | 0;
    var rem = c_0 % 36 | 0;
    // Inline function 'kotlin.math.floor' call
    var x = c_0 / 36.0;
    var r = Math.floor(x) / 5.0;
    // Inline function 'kotlin.math.floor' call
    var x_0 = rem / 6.0;
    var g = Math.floor(x_0) / 5.0;
    var b = (rem % 6 | 0) / 5.0;
    return Companion_getInstance_2().u1l(r, g, b);
  };
  protoOf(Ansi256).t1l = function () {
    return this.s1l_1 < 8 ? new Ansi16(this.s1l_1 + 30 | 0) : this.s1l_1 < 16 ? new Ansi16((this.s1l_1 - 8 | 0) + 90 | 0) : this.q1k().t1l();
  };
  protoOf(Ansi256).toString = function () {
    return 'Ansi256(code=' + this.s1l_1 + ')';
  };
  protoOf(Ansi256).hashCode = function () {
    return this.s1l_1;
  };
  protoOf(Ansi256).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi256))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi256 ? other : THROW_CCE();
    if (!(this.s1l_1 === tmp0_other_with_cast.s1l_1))
      return false;
    return true;
  };
  function Companion_1() {
    Companion_instance_1 = this;
    this.v1l_1 = polarComponentInfo('HSV', 0.0, 1.0);
  }
  protoOf(Companion_1).n1l = function () {
    return this.v1l_1;
  };
  var Companion_instance_1;
  function Companion_getInstance_1() {
    if (Companion_instance_1 == null)
      new Companion_1();
    return Companion_instance_1;
  }
  function toSRGB$f(h, v, s, n) {
    var k = (n + h) % 6;
    var tmp = v * s;
    // Inline function 'kotlin.comparisons.minOf' call
    var b = 4 - k;
    var tmp$ret$0 = Math.min(k, b, 1.0);
    return v - tmp * coerceAtLeast(tmp$ret$0, 0.0);
  }
  function HSV(h, s, v, alpha) {
    Companion_getInstance_1();
    alpha = alpha === VOID ? 1.0 : alpha;
    this.w1l_1 = h;
    this.x1l_1 = s;
    this.y1l_1 = v;
    this.z1l_1 = alpha;
  }
  protoOf(HSV).p1k = function () {
    return Companion_getInstance_1();
  };
  protoOf(HSV).q1k = function () {
    if (this.x1l_1 < 1.0E-7)
      return Companion_getInstance_2().b1m(this.y1l_1, this.y1l_1, this.y1l_1, this.z1l_1);
    var v = this.y1l_1;
    var h = normalizeDeg_0(this.w1l_1) / 60.0;
    var s = this.x1l_1;
    return SRGB_getInstance().b1m(toSRGB$f(h, v, s, 5), toSRGB$f(h, v, s, 3), toSRGB$f(h, v, s, 1), this.z1l_1);
  };
  protoOf(HSV).toString = function () {
    return 'HSV(h=' + this.w1l_1 + ', s=' + this.x1l_1 + ', v=' + this.y1l_1 + ', alpha=' + this.z1l_1 + ')';
  };
  protoOf(HSV).hashCode = function () {
    var result = getNumberHashCode(this.w1l_1);
    result = imul(result, 31) + getNumberHashCode(this.x1l_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.y1l_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.z1l_1) | 0;
    return result;
  };
  protoOf(HSV).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof HSV))
      return false;
    var tmp0_other_with_cast = other instanceof HSV ? other : THROW_CCE();
    if (!equals(this.w1l_1, tmp0_other_with_cast.w1l_1))
      return false;
    if (!equals(this.x1l_1, tmp0_other_with_cast.x1l_1))
      return false;
    if (!equals(this.y1l_1, tmp0_other_with_cast.y1l_1))
      return false;
    if (!equals(this.z1l_1, tmp0_other_with_cast.z1l_1))
      return false;
    return true;
  };
  function get_ICTCP_RGB_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_RGB_TO_LMS;
  }
  var ICTCP_RGB_TO_LMS;
  function get_ICTCP_LMS_TO_ICTCP() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_TO_ICTCP;
  }
  var ICTCP_LMS_TO_ICTCP;
  function get_ICTCP_LMS_to_RGB() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_to_RGB;
  }
  var ICTCP_LMS_to_RGB;
  function get_ICTCP_ICTCP_to_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_ICTCP_to_LMS;
  }
  var ICTCP_ICTCP_to_LMS;
  function get_ICTCP_CROSSTALK() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_CROSSTALK;
  }
  var ICTCP_CROSSTALK;
  function get_HPE_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return HPE_XYZ_TO_LMS;
  }
  var HPE_XYZ_TO_LMS;
  function get_ICTCP_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_XYZ_TO_LMS;
  }
  var ICTCP_XYZ_TO_LMS;
  var ICTCP_LMS_TO_XYZ;
  function ICtCp() {
  }
  protoOf(ICtCp).h1m = function () {
    var fo = RGBColorSpaces_getInstance().p1m_1.u1m();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = get_ICTCP_ICTCP_to_LMS();
    var v0 = this.d1m_1;
    var v1 = this.e1m_1;
    var v2 = this.f1m_1;
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>' call
    var l = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var m = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var s = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_1 = get_ICTCP_LMS_to_RGB();
    var v0_0 = PqNonlinearity_instance.d1n(l);
    var v1_0 = PqNonlinearity_instance.d1n(m);
    var v2_0 = PqNonlinearity_instance.d1n(s);
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_1, 0, 0) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 0) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 0) * v2_0;
    var g = Matrix__get_impl_xogbpk(this_1, 0, 1) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 1) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 1) * v2_0;
    var b = Matrix__get_impl_xogbpk(this_1, 0, 2) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 2) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 2) * v2_0;
    return RGBColorSpaces_getInstance().p1m_1.b1m(fo.e1n(r), fo.e1n(g), fo.e1n(b), this.g1m_1);
  };
  function PqNonlinearity() {
    this.v1m_1 = 0.1593017578125;
    this.w1m_1 = 78.84375;
    this.x1m_1 = 0.8359375;
    this.y1m_1 = 18.8515625;
    this.z1m_1 = 18.6875;
    this.a1n_1 = 10000.0;
    this.b1n_1 = 6.277394636015326;
    this.c1n_1 = 0.012683313515655966;
  }
  protoOf(PqNonlinearity).d1n = function (x) {
    var vp = spow(x, 0.012683313515655966);
    var n = coerceAtLeast(vp - 0.8359375, 0.0);
    var tmp = n / (18.8515625 - 18.6875 * vp);
    var l = spow_0(tmp, 6.277394636015326);
    return 10000.0 * l;
  };
  protoOf(PqNonlinearity).e1n = function (x) {
    var tmp = x / 10000.0;
    var yp = spow_0(tmp, 0.1593017578125);
    var tmp_0 = 0.8359375 + 18.8515625 * yp;
    var tmp_1 = tmp_0 / (1.0 + 18.6875 * yp);
    return spow_0(tmp_1, 78.84375);
  };
  var PqNonlinearity_instance;
  function PqNonlinearity_getInstance() {
    return PqNonlinearity_instance;
  }
  var properties_initialized_ICtCp_kt_w6y8uv;
  function _init_properties_ICtCp_kt__7vx7or() {
    if (!properties_initialized_ICtCp_kt_w6y8uv) {
      properties_initialized_ICtCp_kt_w6y8uv = true;
      ICTCP_RGB_TO_LMS = scalarDiv(_Matrix___init__impl__q3kp4w_0(1688.0, 2146.0, 262.0, 683.0, 2951.0, 462.0, 99.0, 309.0, 3688.0), 4096.0, true);
      ICTCP_LMS_TO_ICTCP = scalarDiv(_Matrix___init__impl__q3kp4w_0(2048.0, 2048.0, 0.0, 6610.0, -13613.0, 7003.0, 17933.0, -17390.0, -543.0), 4096.0, true);
      ICTCP_LMS_to_RGB = inverse(get_ICTCP_RGB_TO_LMS());
      ICTCP_ICTCP_to_LMS = inverse(get_ICTCP_LMS_TO_ICTCP());
      ICTCP_CROSSTALK = _Matrix___init__impl__q3kp4w_0(0.92, 0.04, 0.04, 0.04, 0.92, 0.04, 0.04, 0.04, 0.92);
      HPE_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.4002, 0.7076, -0.0808, -0.2263, 1.1653, 0.0457, 0.0, 0.0, 0.9182);
      ICTCP_XYZ_TO_LMS = dot(get_ICTCP_CROSSTALK(), get_HPE_XYZ_TO_LMS());
      ICTCP_LMS_TO_XYZ = inverse(get_ICTCP_XYZ_TO_LMS());
    }
  }
  function GammaTransferFunctions(gamma) {
    this.f1n_1 = gamma;
  }
  protoOf(GammaTransferFunctions).d1n = function (x) {
    return spow(x, this.f1n_1);
  };
  protoOf(GammaTransferFunctions).e1n = function (x) {
    return spow(x, 1.0 / this.f1n_1);
  };
  protoOf(GammaTransferFunctions).toString = function () {
    return 'GammaTransferFunctions(gamma=' + this.f1n_1 + ')';
  };
  protoOf(GammaTransferFunctions).hashCode = function () {
    return getNumberHashCode(this.f1n_1);
  };
  protoOf(GammaTransferFunctions).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GammaTransferFunctions))
      return false;
    var tmp0_other_with_cast = other instanceof GammaTransferFunctions ? other : THROW_CCE();
    if (!equals(this.f1n_1, tmp0_other_with_cast.f1n_1))
      return false;
    return true;
  };
  function LinearTransferFunctions() {
  }
  protoOf(LinearTransferFunctions).d1n = function (x) {
    return x;
  };
  protoOf(LinearTransferFunctions).e1n = function (x) {
    return x;
  };
  var LinearTransferFunctions_instance;
  function LinearTransferFunctions_getInstance() {
    return LinearTransferFunctions_instance;
  }
  function RGBColorSpace() {
  }
  function Companion_2() {
    Companion_instance_2 = this;
    this.a1m_1 = RGBColorSpaces_getInstance().i1m_1;
  }
  protoOf(Companion_2).n1l = function () {
    return this.a1m_1.n1l();
  };
  protoOf(Companion_2).k1n = function () {
    return this.a1m_1.k1n();
  };
  protoOf(Companion_2).j1n = function () {
    return this.a1m_1.j1n();
  };
  protoOf(Companion_2).j1c = function () {
    return this.a1m_1.j1c();
  };
  protoOf(Companion_2).u1m = function () {
    return this.a1m_1.u1m();
  };
  protoOf(Companion_2).l1n = function () {
    return this.a1m_1.l1n();
  };
  protoOf(Companion_2).h1n = function (r, g, b, alpha) {
    return this.a1m_1.h1n(r, g, b, alpha);
  };
  protoOf(Companion_2).b1m = function (r, g, b, alpha) {
    return this.a1m_1.b1m(r, g, b, alpha);
  };
  protoOf(Companion_2).g1n = function (r, g, b, alpha) {
    return this.a1m_1.g1n(r, g, b, alpha);
  };
  protoOf(Companion_2).i1n = function (hex) {
    return this.a1m_1.i1n(hex);
  };
  protoOf(Companion_2).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().i1m_1, other);
  };
  protoOf(Companion_2).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().i1m_1);
  };
  var Companion_instance_2;
  function Companion_getInstance_2() {
    if (Companion_instance_2 == null)
      new Companion_2();
    return Companion_instance_2;
  }
  function clamp$copy(receiver, p0, p1, p2, p3) {
    return receiver.m1n(p0, p1, p2, p3);
  }
  function RGB(r, g, b, alpha, space) {
    Companion_getInstance_2();
    this.s1k_1 = r;
    this.t1k_1 = g;
    this.u1k_1 = b;
    this.v1k_1 = alpha;
    this.w1k_1 = space;
  }
  protoOf(RGB).p1k = function () {
    return this.w1k_1;
  };
  protoOf(RGB).n1n = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.s1k_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).o1n = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.t1k_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).p1n = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.u1k_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).q1n = function (space) {
    var f = SRGB_getInstance().u1m();
    return equals(this.w1k_1, space) ? this : equals(this.w1k_1, SRGB_getInstance()) && equals(space, RGBColorSpaces_getInstance().j1m_1) ? space.b1m(f.d1n(this.s1k_1), f.d1n(this.t1k_1), f.d1n(this.u1k_1), this.v1k_1) : equals(this.w1k_1, RGBColorSpaces_getInstance().j1m_1) && equals(space, SRGB_getInstance()) ? space.b1m(f.e1n(this.s1k_1), f.e1n(this.t1k_1), f.e1n(this.u1k_1), this.v1k_1) : this.r1k().w1n(space);
  };
  protoOf(RGB).x1n = function () {
    var tmp$ret$3;
    $l$block: {
      // Inline function 'com.github.ajalt.colormath.model.RGB.srgbHueMinMaxChroma' call
      // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
      var $this$toSRGB = this.q1n(SRGB_getInstance());
      var r = $this$toSRGB.s1k_1;
      var g = $this$toSRGB.t1k_1;
      var b = $this$toSRGB.u1k_1;
      // Inline function 'kotlin.comparisons.minOf' call
      var min = Math.min(r, g, b);
      // Inline function 'kotlin.comparisons.maxOf' call
      var max = Math.max(r, g, b);
      var chroma = max - min;
      var tmp;
      if (chroma < 1.0E-7) {
        tmp = NaN;
      } else if (r === max) {
        tmp = (g - b) / chroma;
      } else if (g === max) {
        tmp = 2 + (b - r) / chroma;
      } else if (b === max) {
        tmp = 4 + (r - g) / chroma;
      } else {
        tmp = 0.0;
      }
      var h = tmp * 60;
      // Inline function 'com.github.ajalt.colormath.model.RGB.toHSV.<anonymous>' call
      var h_0 = normalizeDeg(h);
      var s = max === 0.0 ? 0.0 : chroma / max;
      tmp$ret$3 = new HSV(h_0, s, max, this.v1k_1);
      break $l$block;
    }
    return tmp$ret$3;
  };
  protoOf(RGB).r1k = function () {
    var f = this.w1k_1.u1m();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(this.w1k_1.j1n());
    var v0 = f.d1n(this.s1k_1);
    var v1 = f.d1n(this.t1k_1);
    var v2 = f.d1n(this.u1k_1);
    // Inline function 'com.github.ajalt.colormath.model.RGB.toXYZ.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return XYZColorSpace_0(this.w1k_1.l1n()).b1m(x, y, z, this.v1k_1);
  };
  protoOf(RGB).t1l = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.q1n(SRGB_getInstance());
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = $this$toSRGB.x1n().y1l_1 * 100;
    var value = roundToInt(this_0);
    if (value === 30)
      return new Ansi16(30);
    var v = value / 50 | 0;
    // Inline function 'kotlin.math.roundToInt' call
    var this_1 = $this$toSRGB.u1k_1;
    var tmp$ret$1 = roundToInt(this_1);
    var tmp = imul(tmp$ret$1, 4);
    // Inline function 'kotlin.math.roundToInt' call
    var this_2 = $this$toSRGB.t1k_1;
    var tmp$ret$2 = roundToInt(this_2);
    var tmp_0 = tmp | imul(tmp$ret$2, 2);
    // Inline function 'kotlin.math.roundToInt' call
    var this_3 = $this$toSRGB.s1k_1;
    var ansi = 30 + (tmp_0 | roundToInt(this_3)) | 0;
    return new Ansi16(v === 2 ? ansi + 60 | 0 : ansi);
  };
  protoOf(RGB).y1n = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.q1n(SRGB_getInstance());
    var ri = $this$toSRGB.n1n();
    var gi = $this$toSRGB.o1n();
    var bi = $this$toSRGB.p1n();
    var tmp;
    if (ri === gi && gi === bi) {
      tmp = ri < 8 ? 16 : ri > 248 ? 231 : roundToInt((ri - 8 | 0) / 247.0 * 24.0) + 232 | 0;
    } else {
      // Inline function 'kotlin.math.roundToInt' call
      var this_0 = $this$toSRGB.s1k_1 * 5;
      var tmp$ret$0 = roundToInt(this_0);
      var tmp_0 = 16 + imul(36, tmp$ret$0) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_1 = $this$toSRGB.t1k_1 * 5;
      var tmp$ret$1 = roundToInt(this_1);
      var tmp_1 = tmp_0 + imul(6, tmp$ret$1) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_2 = $this$toSRGB.u1k_1 * 5;
      tmp = tmp_1 + roundToInt(this_2) | 0;
    }
    var code = tmp;
    return new Ansi256(code);
  };
  protoOf(RGB).q1k = function () {
    return this.q1n(RGBColorSpaces_getInstance().i1m_1);
  };
  protoOf(RGB).z1n = function () {
    // Inline function 'com.github.ajalt.colormath.internal.clamp3' call
    var v1 = this.s1k_1;
    var v2 = this.t1k_1;
    var v3 = this.u1k_1;
    var alpha = this.v1k_1;
    var tmp0_container = this.p1k().n1l();
    // Inline function 'kotlin.collections.component1' call
    var c1 = tmp0_container.q(0);
    // Inline function 'kotlin.collections.component2' call
    var c2 = tmp0_container.q(1);
    // Inline function 'kotlin.collections.component3' call
    var c3 = tmp0_container.q(2);
    var tmp;
    var tmp_0;
    var tmp_1;
    var tmp_2;
    var containsLower = c1.z1k_1;
    if (v1 <= c1.a1l_1 ? containsLower <= v1 : false) {
      var containsLower_0 = c2.z1k_1;
      tmp_2 = v2 <= c2.a1l_1 ? containsLower_0 <= v2 : false;
    } else {
      tmp_2 = false;
    }
    if (tmp_2) {
      var containsLower_1 = c3.z1k_1;
      tmp_1 = v3 <= c3.a1l_1 ? containsLower_1 <= v3 : false;
    } else {
      tmp_1 = false;
    }
    if (tmp_1) {
      tmp_0 = 0.0 <= alpha ? alpha <= 1.0 : false;
    } else {
      tmp_0 = false;
    }
    if (tmp_0) {
      tmp = this;
    } else {
      tmp = clamp$copy(this, coerceIn(v1, c1.z1k_1, c1.a1l_1), coerceIn(v2, c2.z1k_1, c2.a1l_1), coerceIn(v3, c3.z1k_1, c3.a1l_1), coerceIn(alpha, 0.0, 1.0));
    }
    return tmp;
  };
  protoOf(RGB).a1o = function (r, g, b, alpha, space) {
    return new RGB(r, g, b, alpha, space);
  };
  protoOf(RGB).m1n = function (r, g, b, alpha, space, $super) {
    r = r === VOID ? this.s1k_1 : r;
    g = g === VOID ? this.t1k_1 : g;
    b = b === VOID ? this.u1k_1 : b;
    alpha = alpha === VOID ? this.v1k_1 : alpha;
    space = space === VOID ? this.w1k_1 : space;
    return $super === VOID ? this.a1o(r, g, b, alpha, space) : $super.a1o.call(this, r, g, b, alpha, space);
  };
  protoOf(RGB).toString = function () {
    return 'RGB(r=' + this.s1k_1 + ', g=' + this.t1k_1 + ', b=' + this.u1k_1 + ', alpha=' + this.v1k_1 + ', space=' + toString(this.w1k_1) + ')';
  };
  protoOf(RGB).hashCode = function () {
    var result = getNumberHashCode(this.s1k_1);
    result = imul(result, 31) + getNumberHashCode(this.t1k_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.u1k_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.v1k_1) | 0;
    result = imul(result, 31) + hashCode(this.w1k_1) | 0;
    return result;
  };
  protoOf(RGB).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof RGB))
      return false;
    var tmp0_other_with_cast = other instanceof RGB ? other : THROW_CCE();
    if (!equals(this.s1k_1, tmp0_other_with_cast.s1k_1))
      return false;
    if (!equals(this.t1k_1, tmp0_other_with_cast.t1k_1))
      return false;
    if (!equals(this.u1k_1, tmp0_other_with_cast.u1k_1))
      return false;
    if (!equals(this.v1k_1, tmp0_other_with_cast.v1k_1))
      return false;
    if (!equals(this.w1k_1, tmp0_other_with_cast.w1k_1))
      return false;
    return true;
  };
  function parseHex(_this__u8e3s4, startIndex) {
    var tmp;
    if (get_hexLength(_this__u8e3s4) > 4) {
      var i = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? imul(startIndex, 2) + 1 | 0 : imul(startIndex, 2);
      tmp = toInt(slice(_this__u8e3s4, numberRangeToNumber(i, i + 1 | 0)), 16);
    } else {
      var i_0 = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? startIndex + 1 | 0 : startIndex;
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.colormath.model.parseHex.<anonymous>' call
      var it = charSequenceGet(_this__u8e3s4, i_0);
      var tmp$ret$1 = toString_0(it) + toString_0(it);
      tmp = toInt(tmp$ret$1, 16);
    }
    return tmp;
  }
  function validateHex(_this__u8e3s4) {
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>' call
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
    var it = get_hexLength(_this__u8e3s4);
    switch (it) {
      case 3:
      case 4:
      case 6:
        var tmp$ret$0 = true;
        break;
      default:
        tmp$ret$0 = it === 8;
        break;
    }
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp$ret$0) {
      // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
      var message = 'Hex string must be in the format "#ffffff" or "ffffff"';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
    return _this__u8e3s4;
  }
  function get_hexLength(_this__u8e3s4) {
    return startsWith(_this__u8e3s4, '#') ? _this__u8e3s4.length - 1 | 0 : _this__u8e3s4.length;
  }
  function get_SRGB_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_R;
  }
  var SRGB_R;
  function get_SRGB_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_G;
  }
  var SRGB_G;
  function get_SRGB_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_B;
  }
  var SRGB_B;
  function get_ACES_WHITE_POINT() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_WHITE_POINT;
  }
  var ACES_WHITE_POINT;
  function get_ACES_AP0_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_R;
  }
  var ACES_AP0_R;
  function get_ACES_AP0_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_G;
  }
  var ACES_AP0_G;
  function get_ACES_AP0_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_B;
  }
  var ACES_AP0_B;
  function get_ACES_AP1_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_R;
  }
  var ACES_AP1_R;
  function get_ACES_AP1_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_G;
  }
  var ACES_AP1_G;
  function get_ACES_AP1_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_B;
  }
  var ACES_AP1_B;
  function RGBColorSpaces$SRGB$lambda($this$$receiver, it) {
    return it.q1k();
  }
  function RGBColorSpaces$BT2020$lambda($this$$receiver, color) {
    var tmp;
    if (color instanceof RGB) {
      tmp = color.q1n($this$$receiver);
    } else {
      if (color instanceof ICtCp) {
        tmp = color.h1m();
      } else {
        tmp = color.r1k().w1n($this$$receiver);
      }
    }
    return tmp;
  }
  function RGBColorSpaces() {
    RGBColorSpaces_instance = this;
    var tmp = this;
    var tmp_0 = Illuminant_getInstance().i1l_1;
    var tmp_1 = SRGBTransferFunctions_instance;
    var tmp_2 = get_SRGB_R();
    var tmp_3 = get_SRGB_G();
    var tmp_4 = get_SRGB_B();
    tmp.i1m_1 = new RGBColorSpaceImpl('sRGB', tmp_0, tmp_1, tmp_2, tmp_3, tmp_4, RGBColorSpaces$SRGB$lambda);
    this.j1m_1 = RGBColorSpace_0('Linear sRGB', Illuminant_getInstance().i1l_1, LinearTransferFunctions_instance, get_SRGB_R(), get_SRGB_G(), get_SRGB_B());
    this.k1m_1 = RGBColorSpace_0('ACES2065-1', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP0_R(), get_ACES_AP0_G(), get_ACES_AP0_B());
    this.l1m_1 = RGBColorSpace_0('ACEScc', get_ACES_WHITE_POINT(), ACESccTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.m1m_1 = RGBColorSpace_0('ACEScct', get_ACES_WHITE_POINT(), ACEScctTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.n1m_1 = RGBColorSpace_0('ACEScg', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.o1m_1 = RGBColorSpace_0('Adobe RGB', Illuminant_getInstance().i1l_1, new GammaTransferFunctions(2.19921875), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.21, 0.71), xyY_init_$Create$(0.15, 0.06));
    var tmp_5 = this;
    var tmp_6 = Illuminant_getInstance().i1l_1;
    var tmp_7 = BT2020TransferFunctions_getInstance();
    var tmp_8 = xyY_init_$Create$(0.708, 0.292);
    var tmp_9 = xyY_init_$Create$(0.17, 0.797);
    var tmp_10 = xyY_init_$Create$(0.131, 0.046);
    tmp_5.p1m_1 = new RGBColorSpaceImpl('BT.2020', tmp_6, tmp_7, tmp_8, tmp_9, tmp_10, RGBColorSpaces$BT2020$lambda);
    this.q1m_1 = RGBColorSpace_0('BT.709', Illuminant_getInstance().i1l_1, BT709TransferFunctions_getInstance(), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.3, 0.6), xyY_init_$Create$(0.15, 0.06));
    this.r1m_1 = RGBColorSpace_0('DCI P3', new WhitePoint('DCI P3', xyY_init_$Create$(0.314, 0.351)), new GammaTransferFunctions(2.6), xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.s1m_1 = RGBColorSpace_0('Display P3', Illuminant_getInstance().i1l_1, SRGBTransferFunctions_instance, xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.t1m_1 = RGBColorSpace_0('ROMM RGB', Illuminant_getInstance().g1l_1, ROMMTransferFunctions_instance, xyY_init_$Create$(0.7347, 0.2653), xyY_init_$Create$(0.1596, 0.8404), xyY_init_$Create$(0.0366, 1.0E-4));
  }
  var RGBColorSpaces_instance;
  function RGBColorSpaces_getInstance() {
    if (RGBColorSpaces_instance == null)
      new RGBColorSpaces();
    return RGBColorSpaces_instance;
  }
  function SRGB() {
    SRGB_instance = this;
    this.c1m_1 = RGBColorSpaces_getInstance().i1m_1;
  }
  protoOf(SRGB).n1l = function () {
    return this.c1m_1.n1l();
  };
  protoOf(SRGB).k1n = function () {
    return this.c1m_1.k1n();
  };
  protoOf(SRGB).j1n = function () {
    return this.c1m_1.j1n();
  };
  protoOf(SRGB).j1c = function () {
    return this.c1m_1.j1c();
  };
  protoOf(SRGB).u1m = function () {
    return this.c1m_1.u1m();
  };
  protoOf(SRGB).l1n = function () {
    return this.c1m_1.l1n();
  };
  protoOf(SRGB).h1n = function (r, g, b, alpha) {
    return this.c1m_1.h1n(r, g, b, alpha);
  };
  protoOf(SRGB).b1m = function (r, g, b, alpha) {
    return this.c1m_1.b1m(r, g, b, alpha);
  };
  protoOf(SRGB).g1n = function (r, g, b, alpha) {
    return this.c1m_1.g1n(r, g, b, alpha);
  };
  protoOf(SRGB).i1n = function (hex) {
    return this.c1m_1.i1n(hex);
  };
  protoOf(SRGB).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().i1m_1, other);
  };
  protoOf(SRGB).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().i1m_1);
  };
  protoOf(SRGB).toString = function () {
    return 'sRGB';
  };
  var SRGB_instance;
  function SRGB_getInstance() {
    if (SRGB_instance == null)
      new SRGB();
    return SRGB_instance;
  }
  function RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, convertImpl) {
    this.b1o_1 = name;
    this.c1o_1 = whitePoint;
    this.d1o_1 = transferFunctions;
    this.e1o_1 = r;
    this.f1o_1 = g;
    this.g1o_1 = b;
    this.h1o_1 = convertImpl;
    this.i1o_1 = zeroOneComponentInfo('RGB');
    this.j1o_1 = _Matrix___get_rowMajor__impl__vmgxkq(rgbToXyzMatrix(this.c1o_1, this.e1o_1, this.f1o_1, this.g1o_1));
    this.k1o_1 = _Matrix___get_rowMajor__impl__vmgxkq(inverse(_Matrix___init__impl__q3kp4w(this.j1o_1)));
  }
  protoOf(RGBColorSpaceImpl).j1c = function () {
    return this.b1o_1;
  };
  protoOf(RGBColorSpaceImpl).l1n = function () {
    return this.c1o_1;
  };
  protoOf(RGBColorSpaceImpl).u1m = function () {
    return this.d1o_1;
  };
  protoOf(RGBColorSpaceImpl).n1l = function () {
    return this.i1o_1;
  };
  protoOf(RGBColorSpaceImpl).j1n = function () {
    return this.j1o_1;
  };
  protoOf(RGBColorSpaceImpl).k1n = function () {
    return this.k1o_1;
  };
  protoOf(RGBColorSpaceImpl).toString = function () {
    return this.b1o_1;
  };
  protoOf(RGBColorSpaceImpl).b1m = function (r, g, b, alpha) {
    return new RGB(r, g, b, alpha, this);
  };
  protoOf(RGBColorSpaceImpl).equals = function (other) {
    if (this === other)
      return true;
    if (!(!(other == null) ? isInterface(other, RGBColorSpace) : false))
      return false;
    if (!(this.b1o_1 === other.j1c()))
      return false;
    if (!this.c1o_1.equals(other.l1n()))
      return false;
    if (!equals(this.d1o_1, other.u1m()))
      return false;
    if (other instanceof RGBColorSpaceImpl) {
      if (!this.e1o_1.equals(other.e1o_1))
        return false;
      if (!this.f1o_1.equals(other.f1o_1))
        return false;
      if (!this.g1o_1.equals(other.g1o_1))
        return false;
    } else {
      if (!contentEquals(this.j1o_1, other.j1n()))
        return false;
      if (!contentEquals(this.k1o_1, other.k1n()))
        return false;
    }
    return true;
  };
  protoOf(RGBColorSpaceImpl).hashCode = function () {
    var result = getStringHashCode(this.b1o_1);
    result = imul(31, result) + this.c1o_1.hashCode() | 0;
    result = imul(31, result) + hashCode(this.d1o_1) | 0;
    result = imul(31, result) + this.e1o_1.hashCode() | 0;
    result = imul(31, result) + this.f1o_1.hashCode() | 0;
    result = imul(31, result) + this.g1o_1.hashCode() | 0;
    return result;
  };
  function SRGBTransferFunctions() {
  }
  protoOf(SRGBTransferFunctions).e1n = function (x) {
    return x <= 0.0031308 ? x * 12.92 : 1.055 * spow(x, 1 / 2.4) - 0.055;
  };
  protoOf(SRGBTransferFunctions).d1n = function (x) {
    return x <= 0.04045 ? x / 12.92 : spow_0((x + 0.055) / 1.055, 2.4);
  };
  var SRGBTransferFunctions_instance;
  function SRGBTransferFunctions_getInstance() {
    return SRGBTransferFunctions_instance;
  }
  function RGBColorSpace_0(name, whitePoint, transferFunctions, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return new RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, RGBColorSpace$lambda);
  }
  function ACESccTransferFunctions() {
    ACESccTransferFunctions_instance = this;
    this.l1o_1 = 3.0517578125E-5;
    this.m1o_1 = 1.52587890625E-5;
    this.n1o_1 = -0.3013698630136986;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.o1o_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACESccTransferFunctions).d1n = function (x) {
    var tmp;
    var tmp_0 = x;
    ACESccTransferFunctions_getInstance();
    if (tmp_0 <= -0.3013698630136986) {
      var tmp_1 = spow_0(2.0, x * 17.52 - 9.72);
      ACESccTransferFunctions_getInstance();
      tmp = (tmp_1 - 1.52587890625E-5) * 2.0;
    } else {
      if (x < this.o1o_1) {
        // Inline function 'kotlin.math.pow' call
        var x_0 = x * 17.52 - 9.72;
        tmp = Math.pow(2.0, x_0);
      } else {
        tmp = 65504.0;
      }
    }
    return tmp;
  };
  protoOf(ACESccTransferFunctions).e1n = function (x) {
    var tmp;
    var tmp_0 = x;
    ACESccTransferFunctions_getInstance();
    if (tmp_0 < 3.0517578125E-5) {
      // Inline function 'kotlin.math.log2' call
      ACESccTransferFunctions_getInstance();
      var x_0 = 1.52587890625E-5 + coerceAtLeast_0(x, 0.0) / 2.0;
      tmp = (log2(x_0) + 9.72) / 17.52;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACESccTransferFunctions_instance;
  function ACESccTransferFunctions_getInstance() {
    if (ACESccTransferFunctions_instance == null)
      new ACESccTransferFunctions();
    return ACESccTransferFunctions_instance;
  }
  function ACEScctTransferFunctions() {
    ACEScctTransferFunctions_instance = this;
    this.p1o_1 = 10.5402377416545;
    this.q1o_1 = 0.0729055341958355;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.r1o_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACEScctTransferFunctions).d1n = function (x) {
    var tmp;
    if (x <= 0.155251141552511) {
      ACEScctTransferFunctions_getInstance();
      var tmp_0 = x - 0.0729055341958355;
      ACEScctTransferFunctions_getInstance();
      tmp = tmp_0 / 10.5402377416545;
    } else if (x < this.r1o_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACEScctTransferFunctions).e1n = function (x) {
    var tmp;
    if (x < 0.0078125) {
      ACEScctTransferFunctions_getInstance();
      var tmp_0 = 10.5402377416545 * x;
      ACEScctTransferFunctions_getInstance();
      tmp = tmp_0 + 0.0729055341958355;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACEScctTransferFunctions_instance;
  function ACEScctTransferFunctions_getInstance() {
    if (ACEScctTransferFunctions_instance == null)
      new ACEScctTransferFunctions();
    return ACEScctTransferFunctions_instance;
  }
  function BT2020TransferFunctions() {
    BT2020TransferFunctions_instance = this;
    this.s1o_1 = 1.0993;
    this.t1o_1 = 0.0181;
    var tmp = this;
    BT2020TransferFunctions_getInstance();
    // Inline function 'kotlin.math.pow' call
    BT2020TransferFunctions_getInstance();
    var tmp_0 = 1.0993 * Math.pow(0.0181, 0.45);
    BT2020TransferFunctions_getInstance();
    tmp.u1o_1 = tmp_0 - (1.0993 - 1);
  }
  protoOf(BT2020TransferFunctions).d1n = function (x) {
    var tmp;
    if (x < this.u1o_1) {
      tmp = x / 4.5;
    } else {
      BT2020TransferFunctions_getInstance();
      var tmp_0 = x + (1.0993 - 1);
      BT2020TransferFunctions_getInstance();
      tmp = spow_0(tmp_0 / 1.0993, 1 / 0.45);
    }
    return numberToDouble(tmp);
  };
  protoOf(BT2020TransferFunctions).e1n = function (x) {
    var tmp;
    var tmp_0 = x;
    BT2020TransferFunctions_getInstance();
    if (tmp_0 < 0.0181) {
      tmp = 4.5 * x;
    } else {
      BT2020TransferFunctions_getInstance();
      var tmp_1 = 1.0993 * spow(x, 0.45);
      BT2020TransferFunctions_getInstance();
      tmp = tmp_1 - (1.0993 - 1);
    }
    return tmp;
  };
  var BT2020TransferFunctions_instance;
  function BT2020TransferFunctions_getInstance() {
    if (BT2020TransferFunctions_instance == null)
      new BT2020TransferFunctions();
    return BT2020TransferFunctions_instance;
  }
  function BT709TransferFunctions() {
    BT709TransferFunctions_instance = this;
    this.v1o_1 = 1.099 * spow_0(0.018, 0.45) - 0.099;
  }
  protoOf(BT709TransferFunctions).d1n = function (x) {
    return numberToDouble(x < this.v1o_1 ? x / 4.5 : spow_0((x + 0.099) / 1.099, 1 / 0.45));
  };
  protoOf(BT709TransferFunctions).e1n = function (x) {
    return x < 0.018 ? 4.5 * x : 1.099 * spow(x, 0.45) - 0.099;
  };
  var BT709TransferFunctions_instance;
  function BT709TransferFunctions_getInstance() {
    if (BT709TransferFunctions_instance == null)
      new BT709TransferFunctions();
    return BT709TransferFunctions_instance;
  }
  function ROMMTransferFunctions() {
    this.w1o_1 = 0.001953;
  }
  protoOf(ROMMTransferFunctions).d1n = function (x) {
    var tmp;
    var tmp_0 = x;
    if (tmp_0 < 16 * 0.001953) {
      tmp = x / 16.0;
    } else {
      tmp = spow(x, 1.8);
    }
    return tmp;
  };
  protoOf(ROMMTransferFunctions).e1n = function (x) {
    var tmp;
    var tmp_0 = x;
    if (tmp_0 < 0.001953) {
      tmp = x * 16.0;
    } else {
      tmp = spow(x, 1.0 / 1.8);
    }
    return tmp;
  };
  var ROMMTransferFunctions_instance;
  function ROMMTransferFunctions_getInstance() {
    return ROMMTransferFunctions_instance;
  }
  function rgbToXyzMatrix(whitePoint, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var primaries = _Matrix___init__impl__q3kp4w_0(r.x1o_1, g.x1o_1, b.x1o_1, r.y1o_1, g.y1o_1, b.y1o_1, r.a1p(), g.a1p(), b.a1p());
    var wp = whitePoint.c1l_1;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = inverse(primaries);
    var v0 = wp.b1p();
    var v1 = wp.z1o_1;
    var v2 = wp.c1p();
    // Inline function 'com.github.ajalt.colormath.model.rgbToXyzMatrix.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return dotDiagonal(primaries, x, y, z);
  }
  function RGBColorSpace$lambda($this$$receiver, color) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var tmp;
    if (color instanceof RGB) {
      tmp = color.q1n($this$$receiver);
    } else {
      tmp = color.r1k().w1n($this$$receiver);
    }
    return tmp;
  }
  var properties_initialized_RGBColorSpaces_kt_fsnpad;
  function _init_properties_RGBColorSpaces_kt__nc9fsz() {
    if (!properties_initialized_RGBColorSpaces_kt_fsnpad) {
      properties_initialized_RGBColorSpaces_kt_fsnpad = true;
      SRGB_R = xyY_init_$Create$(0.64, 0.33);
      SRGB_G = xyY_init_$Create$(0.3, 0.6);
      SRGB_B = xyY_init_$Create$(0.15, 0.06);
      ACES_WHITE_POINT = new WhitePoint('ACES', xyY_init_$Create$(0.32168, 0.33767));
      ACES_AP0_R = xyY_init_$Create$(0.7347, 0.2653);
      ACES_AP0_G = xyY_init_$Create$(0.0, 1.0);
      ACES_AP0_B = xyY_init_$Create$(1.0E-4, -0.077);
      ACES_AP1_R = xyY_init_$Create$(0.713, 0.293);
      ACES_AP1_G = xyY_init_$Create$(0.165, 0.83);
      ACES_AP1_B = xyY_init_$Create$(0.128, 0.044);
    }
  }
  function Companion_3() {
    Companion_instance_3 = this;
    this.d1p_1 = XYZColorSpaces_getInstance().e1p_1;
  }
  protoOf(Companion_3).n1l = function () {
    return this.d1p_1.n1l();
  };
  protoOf(Companion_3).l1n = function () {
    return this.d1p_1.l1n();
  };
  protoOf(Companion_3).b1m = function (x, y, z, alpha) {
    return this.d1p_1.b1m(x, y, z, alpha);
  };
  protoOf(Companion_3).hashCode = function () {
    return hashCode(XYZColorSpaces_getInstance().e1p_1);
  };
  protoOf(Companion_3).equals = function (other) {
    return equals(XYZColorSpaces_getInstance().e1p_1, other);
  };
  var Companion_instance_3;
  function Companion_getInstance_3() {
    if (Companion_instance_3 == null)
      new Companion_3();
    return Companion_instance_3;
  }
  function adaptToM($this, space, m, mi) {
    if (space.l1n().equals($this.v1n_1.l1n()))
      return $this;
    var transform = chromaticAdaptationMatrix(space, $this.v1n_1.l1n().c1l_1, m, mi);
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var v0 = $this.r1n_1;
    var v1 = $this.s1n_1;
    var v2 = $this.t1n_1;
    // Inline function 'com.github.ajalt.colormath.model.XYZ.adaptToM.<anonymous>' call
    var xx = Matrix__get_impl_xogbpk(transform, 0, 0) * v0 + Matrix__get_impl_xogbpk(transform, 1, 0) * v1 + Matrix__get_impl_xogbpk(transform, 2, 0) * v2;
    var yy = Matrix__get_impl_xogbpk(transform, 0, 1) * v0 + Matrix__get_impl_xogbpk(transform, 1, 1) * v1 + Matrix__get_impl_xogbpk(transform, 2, 1) * v2;
    var zz = Matrix__get_impl_xogbpk(transform, 0, 2) * v0 + Matrix__get_impl_xogbpk(transform, 1, 2) * v1 + Matrix__get_impl_xogbpk(transform, 2, 2) * v2;
    return space.b1m(xx, yy, zz, $this.u1n_1);
  }
  function XYZ(x, y, z, alpha, space) {
    Companion_getInstance_3();
    this.r1n_1 = x;
    this.s1n_1 = y;
    this.t1n_1 = z;
    this.u1n_1 = alpha;
    this.v1n_1 = space;
  }
  protoOf(XYZ).p1k = function () {
    return this.v1n_1;
  };
  protoOf(XYZ).g1p = function (space) {
    return adaptToM(this, space, get_CAT02_XYZ_TO_LMS(), get_CAT02_LMS_TO_XYZ());
  };
  protoOf(XYZ).w1n = function (space) {
    var tmp0_container = this.g1p(XYZColorSpace_0(space.l1n()));
    var x = tmp0_container.v9();
    var y = tmp0_container.w9();
    var z = tmp0_container.kh();
    var f = space.u1m();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(space.k1n());
    // Inline function 'com.github.ajalt.colormath.model.XYZ.toRGB.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_0, 0, 0) * x + Matrix__get_impl_xogbpk(this_0, 1, 0) * y + Matrix__get_impl_xogbpk(this_0, 2, 0) * z;
    var g = Matrix__get_impl_xogbpk(this_0, 0, 1) * x + Matrix__get_impl_xogbpk(this_0, 1, 1) * y + Matrix__get_impl_xogbpk(this_0, 2, 1) * z;
    var b = Matrix__get_impl_xogbpk(this_0, 0, 2) * x + Matrix__get_impl_xogbpk(this_0, 1, 2) * y + Matrix__get_impl_xogbpk(this_0, 2, 2) * z;
    return space.b1m(f.e1n(r), f.e1n(g), f.e1n(b), this.u1n_1);
  };
  protoOf(XYZ).q1k = function () {
    return this.w1n(RGBColorSpaces_getInstance().i1m_1);
  };
  protoOf(XYZ).r1k = function () {
    return this;
  };
  protoOf(XYZ).v9 = function () {
    return this.r1n_1;
  };
  protoOf(XYZ).w9 = function () {
    return this.s1n_1;
  };
  protoOf(XYZ).kh = function () {
    return this.t1n_1;
  };
  protoOf(XYZ).toString = function () {
    return 'XYZ(x=' + this.r1n_1 + ', y=' + this.s1n_1 + ', z=' + this.t1n_1 + ', alpha=' + this.u1n_1 + ', space=' + toString(this.v1n_1) + ')';
  };
  protoOf(XYZ).hashCode = function () {
    var result = getNumberHashCode(this.r1n_1);
    result = imul(result, 31) + getNumberHashCode(this.s1n_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.t1n_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.u1n_1) | 0;
    result = imul(result, 31) + hashCode(this.v1n_1) | 0;
    return result;
  };
  protoOf(XYZ).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof XYZ))
      return false;
    var tmp0_other_with_cast = other instanceof XYZ ? other : THROW_CCE();
    if (!equals(this.r1n_1, tmp0_other_with_cast.r1n_1))
      return false;
    if (!equals(this.s1n_1, tmp0_other_with_cast.s1n_1))
      return false;
    if (!equals(this.t1n_1, tmp0_other_with_cast.t1n_1))
      return false;
    if (!equals(this.u1n_1, tmp0_other_with_cast.u1n_1))
      return false;
    if (!equals(this.v1n_1, tmp0_other_with_cast.v1n_1))
      return false;
    return true;
  };
  function XYZColorSpace() {
  }
  function XYZColorSpace_0(whitePoint) {
    return whitePoint.equals(Illuminant_getInstance().i1l_1) ? XYZColorSpaces_getInstance().e1p_1 : whitePoint.equals(Illuminant_getInstance().g1l_1) ? XYZColorSpaces_getInstance().f1p_1 : new XYZColorSpaceImpl(whitePoint);
  }
  function XYZColorSpaces() {
    XYZColorSpaces_instance = this;
    this.e1p_1 = new XYZColorSpaceImpl(Illuminant_getInstance().i1l_1);
    this.f1p_1 = new XYZColorSpaceImpl(Illuminant_getInstance().g1l_1);
  }
  var XYZColorSpaces_instance;
  function XYZColorSpaces_getInstance() {
    if (XYZColorSpaces_instance == null)
      new XYZColorSpaces();
    return XYZColorSpaces_instance;
  }
  function chromaticAdaptationMatrix(_this__u8e3s4, srcWp, xyzToLms, lmsToXyz) {
    xyzToLms = xyzToLms === VOID ? get_CAT02_XYZ_TO_LMS() : xyzToLms;
    lmsToXyz = lmsToXyz === VOID ? get_CAT02_LMS_TO_XYZ() : lmsToXyz;
    var dstWp = _this__u8e3s4.l1n().c1l_1;
    var src = dot_0(xyzToLms, srcWp.b1p(), srcWp.z1o_1, srcWp.c1p());
    var dst = dot_0(xyzToLms, dstWp.b1p(), dstWp.z1o_1, dstWp.c1p());
    return dot(dotDiagonal(lmsToXyz, _Vector___get_l__impl__envr1l(dst) / _Vector___get_l__impl__envr1l(src), _Vector___get_m__impl__e5qq0m(dst) / _Vector___get_m__impl__e5qq0m(src), _Vector___get_s__impl__pzuljk(dst) / _Vector___get_s__impl__pzuljk(src)), xyzToLms);
  }
  function XYZColorSpaceImpl(whitePoint) {
    this.h1p_1 = whitePoint;
    this.i1p_1 = zeroOneComponentInfo('XYZ');
  }
  protoOf(XYZColorSpaceImpl).l1n = function () {
    return this.h1p_1;
  };
  protoOf(XYZColorSpaceImpl).n1l = function () {
    return this.i1p_1;
  };
  protoOf(XYZColorSpaceImpl).toString = function () {
    return 'XYZColorSpace(' + this.h1p_1.toString() + ')';
  };
  protoOf(XYZColorSpaceImpl).b1m = function (x, y, z, alpha) {
    return new XYZ(x, y, z, alpha, this);
  };
  protoOf(XYZColorSpaceImpl).hashCode = function () {
    return this.h1p_1.hashCode();
  };
  protoOf(XYZColorSpaceImpl).equals = function (other) {
    var tmp;
    if (!(other == null) ? isInterface(other, XYZColorSpace) : false) {
      tmp = this.h1p_1.equals(other.l1n());
    } else {
      tmp = false;
    }
    return tmp;
  };
  function xyY_init_$Init$(x, y, Y, $this) {
    Y = Y === VOID ? 1.0 : Y;
    xyY.call($this, numberToDouble(x), numberToDouble(y), numberToDouble(Y));
    return $this;
  }
  function xyY_init_$Create$(x, y, Y) {
    return xyY_init_$Init$(x, y, Y, objectCreate(protoOf(xyY)));
  }
  function xyY(x, y, Y) {
    Y = Y === VOID ? 1.0 : Y;
    this.x1o_1 = x;
    this.y1o_1 = y;
    this.z1o_1 = Y;
  }
  protoOf(xyY).a1p = function () {
    return 1 - this.x1o_1 - this.y1o_1;
  };
  protoOf(xyY).b1p = function () {
    return this.x1o_1 * this.z1o_1 / this.y1o_1;
  };
  protoOf(xyY).c1p = function () {
    return (1 - this.x1o_1 - this.y1o_1) * this.z1o_1 / this.y1o_1;
  };
  protoOf(xyY).toString = function () {
    return 'xyY(x=' + this.x1o_1 + ', y=' + this.y1o_1 + ', Y=' + this.z1o_1 + ')';
  };
  protoOf(xyY).hashCode = function () {
    var result = getNumberHashCode(this.x1o_1);
    result = imul(result, 31) + getNumberHashCode(this.y1o_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.z1o_1) | 0;
    return result;
  };
  protoOf(xyY).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof xyY))
      return false;
    var tmp0_other_with_cast = other instanceof xyY ? other : THROW_CCE();
    if (!equals(this.x1o_1, tmp0_other_with_cast.x1o_1))
      return false;
    if (!equals(this.y1o_1, tmp0_other_with_cast.y1o_1))
      return false;
    if (!equals(this.z1o_1, tmp0_other_with_cast.z1o_1))
      return false;
    return true;
  };
  //region block: post-declaration
  protoOf(Ansi16).r1k = toXYZ;
  protoOf(Ansi256).r1k = toXYZ;
  protoOf(HSV).r1k = toXYZ;
  protoOf(Companion_2).q1l = from255$default;
  protoOf(Companion_2).p1l = invoke$default;
  protoOf(Companion_2).u1l = invoke$default_0;
  protoOf(SRGB).q1l = from255$default;
  protoOf(SRGB).p1l = invoke$default;
  protoOf(SRGB).u1l = invoke$default_0;
  protoOf(RGBColorSpaceImpl).p1l = invoke$default;
  protoOf(RGBColorSpaceImpl).g1n = invoke;
  protoOf(RGBColorSpaceImpl).u1l = invoke$default_0;
  protoOf(RGBColorSpaceImpl).i1n = invoke_0;
  protoOf(RGBColorSpaceImpl).h1n = from255;
  protoOf(RGBColorSpaceImpl).q1l = from255$default;
  //endregion
  //region block: init
  PqNonlinearity_instance = new PqNonlinearity();
  LinearTransferFunctions_instance = new LinearTransferFunctions();
  SRGBTransferFunctions_instance = new SRGBTransferFunctions();
  ROMMTransferFunctions_instance = new ROMMTransferFunctions();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Ansi16;
  _.$_$.b = Ansi256;
  _.$_$.c = Companion_getInstance_2;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=colormath-root-colormath.js.map
